

/* dPi.c */

/* differential Pi */

/* 95-01-14 by psycho. */

#include <stdio.h>
#include <stdlib.h>

#include <iocslib.h>
#include <doslib.h>
/*
#define _DEBUG_
*/

#define FALSE (0)
#define TRUE  (1)


#define BUF_DIF (8192)

#define G_VRAM  ((unsigned short *)0xc00000)


/* for xpi_load.s */
extern int PiLoad( char * , short * , int , int , int , int , int , int , int ) ;

#define PIOPT_SET_PALET	0x01
#define PIOPT_EXT_DISP	0x02
#define PIOPT_COM_DISP	0x04
#define PIOPT_SET_SCR	0x08
#define PIOPT_MEM_LESS	0x10


int PIOPT = ( PIOPT_SET_PALET | PIOPT_SET_SCR ) ;		/* PiLoad IvV */
unsigned char Color ;									/* F (0`15)
														   ȏゾƁAʓI
														   ʂɃ[h  */

int HexToI ( char *Hex )
{
	int Ans = 0 ;

	for ( ; *Hex ; Hex++ )
		{
		Ans <<= 4 ;
		if ( ( 'a' <= *Hex ) && ( *Hex <= 'f' ) ) { Ans += *Hex - 'a' + 0x0a ; }
		else if ( ( 'A' <= *Hex ) && ( *Hex <= 'F' ) ) { Ans += *Hex - 'A' + 0x0a ; }
		else if ( ( '0' <= *Hex ) && ( *Hex <= '9' ) ) { Ans += *Hex - '0' ; }
		else break ;
		}

	return Ans ;
}


void Usage ( void )
{
	fputs ( "\
X68k differential Pi v0.01  (c)1990,91 Ȃ / 1995 psycho.\n\
usage> dPi [-(options)] [filename...]\n\
	-x<num>	̂wW<num>ɂ܂\n\
	-y<num>	̂xW<num>ɂ܂\n\
	-c<num>	J[R[h<num>Ԃ`悵܂(ftHg͂O)\n\
	-h	̃wv\܂\n" , stderr ) ;

	return ;
}


int DiffPiLoad ( char *PiName , int Xpos , int Ypos , int XposEnd , int YposEnd )
{
	int PiFH , BufferSize ;
	unsigned int PiXsize , PiYsize ;
	short *ExtBuffer ;
	int _x , _y ;
	char _c , __c = Color ;
	char *__p ;
	short *__g ;


	if ( ( ( PiName == NULL ) || ( Xpos >= 1024 ) || ( Ypos >= 1024 ) || \
			( XposEnd >= 1024 ) || ( YposEnd >= 1024 ) ) || \
			( ( PiFH = OPEN ( PiName , 0x000 ) ) < 0 ) ) return FALSE ;
	else
		{
		int HeaderLength ;

		if ( ( FGETC ( PiFH ) != 'P' ) || ( FGETC ( PiFH ) != 'i' ) )
			{ CLOSE ( PiFH ) ; return FALSE ; }

		/* RgXLbv */
		while ( FGETC ( PiFH ) != 0x1a ) ;
		while ( FGETC ( PiFH ) != 0x00 ) ;

		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;

		/* Z[ohcXLbv */

		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;
		FGETC ( PiFH ) ;

		FGETC ( PiFH ) ;

		HeaderLength = FGETC ( PiFH ) ;

		if ( HeaderLength == 0x05 )
			{
			FGETC ( PiFH ) ;
			if ( Xpos < 0 ) Xpos = ( FGETC ( PiFH ) << 8 ) + FGETC ( PiFH ) ;
			else { FGETC ( PiFH ) ; FGETC ( PiFH ) ; }
			if ( Ypos < 0 ) Ypos = ( FGETC ( PiFH ) << 8 ) + FGETC ( PiFH ) ;
			else { FGETC ( PiFH ) ; FGETC ( PiFH ) ; }
			}
		else while ( HeaderLength-- ) FGETC ( PiFH ) ;

		PiXsize = ( FGETC ( PiFH ) << 8 ) + FGETC ( PiFH ) ;
		PiYsize = ( FGETC ( PiFH ) << 8 ) + FGETC ( PiFH ) ;

#ifdef _DEBUG_
		fprintf ( stderr , "\
PiSize X : %d  Y : %d\n" , PiXsize , PiYsize ) ;
#endif

		CLOSE ( PiFH ) ;
		}

	if ( ( PiXsize > 1024 ) || ( PiYsize > 1024 ) ) return FALSE ;

	if ( XposEnd ) Xpos = XposEnd - PiXsize ;
	if ( YposEnd ) Ypos = YposEnd - PiYsize ;

	if ( Xpos < 0 ) Xpos = 0 ;
	if ( Ypos < 0 ) Ypos = 0 ;


	BufferSize = ( ( PiXsize * PiYsize ) + BUF_DIF ) ;

	if ( BufferSize % BUF_DIF ) BufferSize = ( ( BufferSize / BUF_DIF ) + 1 ) * BUF_DIF ;

#ifdef _DEBUG_

	fprintf ( stderr , "\
BufferSize : %d\n\
FileName : %s\n\
Xpos : %d\n\
Ypos : %d\n\
PiXsize : %d\n\
PiYsize : %d\n" , BufferSize , PiName , Xpos , Ypos , PiXsize , PiYsize ) ;

#endif


	if ( ( ExtBuffer = (short *)MALLOC ( BufferSize ) ) < (short *)0x81000000 )
		{

		__p = ( (unsigned char *)ExtBuffer + 2048 ) ;

		/* \ */

		if ( PiLoad ( PiName , ExtBuffer , BufferSize , 0 , 0 , (-1) , (-1) , 100 , (char) PIOPT ) == 0 )
			{
			int SSP = SUPER ( 0 ) ;
			/* Phbgh[^^; */

			for ( _y = 0 ; _y < PiYsize ; _y++ )
				{
				__g = G_VRAM + ( ( ( _y + Ypos ) * 1024 ) + ( Xpos ) ) ;

				for ( _x = PiXsize ; _x ; _x-- )
					{
					if ( ( _c = *__p++ ) != __c ) * ( __g++ ) = _c ;
					else __g++ ;
					}
				}
			if ( SSP > 0 ) SUPER ( SSP ) ;
			}

		MFREE ( (int) ExtBuffer ) ;
		}
	else return FALSE ;

	return TRUE ;
}


int main ( int argc , char **argv )
{
	int Xpos = (-1) , Ypos = (-1) , XposEnd = 0 , YposEnd = 0 ;


	if ( TGUSEMD ( 0 , (-1) ) == 2 ) return 1 ;

	Color = 0x00 ;

	while ( *(++argv) )
		{
		if ( **argv != '-' )
			{
			if ( ! DiffPiLoad ( *argv , Xpos , Ypos , XposEnd , YposEnd ) )
				{
				fputs ( "Error : [ho܂ł : " , stderr ) ;
				fputs ( *argv , stderr ) ; fputc ( '\n' , stderr ) ;
				}
			}
		else
			{
#ifdef _DEBUG_
			fprintf ( stderr , "\
argv : %s\n" , *argv ) ;
#endif
			switch ( *(*argv+1) )
				{
				case 'x' :
				if ( *(*argv+2) ) Xpos = atoi ( *argv+2 ) ;
				else Xpos = (-1) ;
				break ;

				case 'y' :
				if ( *(*argv+2) ) Ypos = atoi ( *argv+2 ) ;
				else Ypos = (-1) ;
				break ;

				case 'X' :
				if ( *(*argv+2) ) XposEnd = atoi ( *argv+2 ) ;
				else XposEnd = 0 ;
				break ;

				case 'Y' :
				if ( *(*argv+2) ) YposEnd = atoi ( *argv+2 ) ;
				else YposEnd = 0 ;
				break ;

				case 'i' :
				CRTMOD ( 0x010 ) ; G_CLR_ON () ;
				break ;

				case 'c' :
				if ( *(*argv+2) )
					{
					if ( ( ( *(*argv+2) == '0' ) && ( *(*argv+3) == 'x' ) ) || \
						( ( *(*argv+2) == '0' ) && ( *(*argv+3) == 'X' ) ) ) Color = HexToI ( *argv+4 ) ;
					else if ( ( *(*argv+2) == 'x' ) || ( *(*argv+2) == 'X' ) ) Color = HexToI ( *argv+3 ) ;
					else Color = atoi ( *argv+2 ) ;
					
					}
				break ;

				case 'n' :
				PIOPT ^= PIOPT_SET_SCR ;
				break ;

				case 'h' :
				case '?' :
				Usage () ;
				return 0 ;

				}
			}
		}

	return 0 ;

}
